require 'singleton'

class MissingCredentialsError < RuntimeError
end

class RapidAPI::Config
  def self.setup(**args)
    @@project = args[:project]
    @@token = args[:token]
    return
  end

  def self.project
    @@project || raise(MissingCredentialsError, 'Project name not set')
  end

  def self.token
    @@token || raise(MissingCredentialsError, 'Token not set')
  end
end