require 'net/http'
require 'net/http/post/multipart'
require 'json'
require 'rapidapi/version'
require 'rapidapi/config'

module RapidAPI
  class << self

    def config(**args)
      RapidAPI::Config.setup(args)
    end

    def call(package_name, block_name, args={})

      uri = build_uri(package_name, block_name)
      req = build_request(uri, args)
      res = Net::HTTP.start(uri.hostname, uri.port) { |http|
        http.request(req)
      }
      reply = JSON.parse(res.body)

      unless res.code.to_i == 200
        reply['outcome'] = 'error'
      end

      reply
    end

    def build_uri(package, block)
      URI("http://rapidapi.io/connect/#{package}/#{block}")
    end

    def build_request(uri, form_data)

      config = RapidAPI::Config

      req = Net::HTTP::Post::Multipart.new(uri, form_data)
      req.basic_auth(config.project, config.token)

      req
    end
  end
end
